local visible
local mask
local shader

function love.load()
	visible = love.graphics.newImage("visible.png")
	mask    = love.graphics.newImage("mask.png")

	local code = love.filesystem.read("shader.frag")
	shader = love.graphics.newShader(code)

	love.window.setMode(visible:getWidth(), visible:getHeight(), { resizable = true, vsync = true, borderless = false })
	love.graphics.setDefaultFilter("nearest", "nearest", 1)
end

function love.update(dt)
	shader:send("light_radius", 100)
	shader:send("ambient", 0.33) -- ambient lighting for areas where there is no direct light
	local x, y = love.mouse.getPosition()
	shader:send("light_pos", { x, y })
	shader:send("wall_height", 1.0) -- try wall_height 0.5 it is like when walls are lower then light source
	shader:send("size", { visible:getWidth(), visible:getHeight() })
	shader:send("collision_mask", mask)
end

function love.draw()
	love.graphics.setShader(shader)
	love.graphics.draw(visible)
end
